/* linear AIFF  data ñ˷Ҥ
 * shige
 * 10/01 2000
 * aiffconn.c
 *
 * $Id: aiffconn.c,v 1.3 2001-12-25 14:49:46+09 shige Exp $
 */
#ifndef __AIFFCONN_C__
#define __AIFFCONN_C__

#include "aiffconn.h"

/* ########## main routine ########## */
int main(int argc,char *argv[],char *env[])
{
    int j,j0,k,N,inoption;
    char c;
    AIFFdata aiffdata[Maxdatanum];
    int len=-1,dlen,addsp=0,a_bs,a_ch,a_byte,a_blocks,fblock;
    int dataonly=0;

    if(argc<2){ usage(); return Exit_noarg; }
    inithome(env);
    undefs="undefined";
    NULLFname=undefs;
    j=1;
    if(*argv[j]=='-'){
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'p':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2pathlist(argv[j])<0){
		    usage();
		    return Exit_addstr2pathlist;
		}
		inoption=0;
		break;
	    case 'e':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2extlist(argv[j])<0){
		    usage();
		    return Exit_addstr2extlist;
		}
		inoption=0;
		break;
	    case 'f':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		DEFAULTConffname=argv[j];
#if 0
		if(addfile2list(argv[j])<0){
		    usage();
		    return Exit_addfile2list;
		}
#endif /* 0 */
		inoption=0;
		break;
	    case 'q':
		verbose=0;
		inoption=1;
		break;
	    case 'l':
		listonly=1;
		inoption=1;
		break;
	    case 'r':
		dataonly=1;
		break;
	    case 'n':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(*argv[j]=='-') NULLFname=NULL;
		else NULLFname=argv[j];
		inoption=0;
		break;
	    case 'L':
		if(*++argv[j]=='b') fblock=1;
		else if(*argv[j]=='s') fblock=0;
		else{ usage(); return Exit_invalid_arg; }
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if((k=strlen(argv[j]))<=0){ usage(); return Exit_invalid_arg; }
		if(*(argv[j]+k-1)=='+'){ addsp=1; *(argv[j]+k-1)='\0'; }
		else if(*(argv[j]+k-1)=='-'){ addsp=-1; *(argv[j]+k-1)='\0'; }
		else addsp=0;
		if((len=atoi(argv[j]))<=0){ usage(); return Exit_invalid_arg; }
		inoption=0;
		break;
	    case 'h':
		usage(); return Exit_help;
	    default:
		usage(); return Exit_unknownarg;
	    }
	    if(inoption && (c=*(++argv[j]))!='\0') continue;
	    if(++j>=argc){ usage(); return Exit_noarg; }
	    if(*argv[j]!='-') break;
	    c=*(++argv[j]);
	}
    }
    if(initpathextlist(env)<0){
	usage();
	return Exit_envdefault;
    }
    if(listonly){
	for(k=j;k<argc;k++)
#ifdef USEFREOPEN
	  if((tmpfile1=fopenpathlist(argv[k],tmpfile1))!=NULL
	     ||(NULLFname!=NULL 
		&& (tmpfile1=fopenpathlist(NULLFname,tmpfile1))!=NULL)){
	      fclose(tmpfile1); tmpfile1=NULL;
	  }
#else
	  if((tmpfile1=fopenpathlist(argv[k]))!=NULL
	     ||(NULLFname!=NULL && (tmpfile1=fopenpathlist(NULLFname))!=NULL))
	    fclose(tmpfile1);
#endif
	return No_err;
    }
    j0=j;
    if(argc-1-j0+1>Maxdatanum){ usage(); return Exit_toomanyarg; }
    N=argc-1-j0+1;
    /* 1 ܤ file 򳫤 */
#ifdef USEFREOPEN
    if((tmpfile1=fopenpathlist(argv[j0],tmpfile1))==NULL){
	if(NULLFname==NULL||(tmpfile1=fopenpathlist(NULLFname,tmpfile1))==NULL)
#else
    if((tmpfile1=fopenpathlist(argv[j0]))==NULL){
	if(NULLFname==NULL||(tmpfile1=fopenpathlist(NULLFname))==NULL)
#endif
	  return Exit_openpathfile;
	else argv[j0]=NULLFname;
    }
    if(getAIFFheader(tmpfile1,&aiffdata[0])<0) return Exit_getAIFFheader;
#ifndef USEFREOPEN
    fclose(tmpfile1);
#endif
    if((j=aiffdata[0].bitpersmpl)!=8 && j!=16) return Exit_unsupported_format;
    /* 2 ܰʹߤ file 򳫤 header  1 ܤΤΤ */
    for(j=2;j<=N;j++){
#ifdef USEFREOPEN
	if((tmpfile1=fopenpathlist(argv[j0+j-1],tmpfile1))==NULL){ 
	    if(NULLFname==NULL
	       ||(tmpfile1=fopenpathlist(NULLFname,tmpfile1))==NULL)
#else
        if((tmpfile1=fopenpathlist(argv[j0+j-1]))==NULL){ 
	    if(NULLFname==NULL||(tmpfile1=fopenpathlist(NULLFname))==NULL)
#endif
	      return Exit_openpathfile;
	    else argv[j0+j-1]=NULLFname;
	}
	if(getAIFFheader(tmpfile1,&aiffdata[j-1])<0) return Exit_getAIFFheader;
#ifndef USEFREOPEN
	fclose(tmpfile1);
#endif
	if(chAIFFheader(&aiffdata[j-1],&aiffdata[0])<0) return Exit_chAIFFheader;
    }
    if(!fblock) len=len*(aiffdata[0].smplrate).x/1000;
    /*  */
    if(!dataonly) putallAIFFheader2(stdout,aiffdata,N,len,addsp);
    a_bs=aiffdata[0].flamesize;
    a_ch=aiffdata[0].channel;
    a_byte=a_bs/a_ch;
    for(j=1;j<=N;j++){
#ifdef USEFREOPEN
	if((tmpfile1=fopenpathlist(argv[j0+j-1],tmpfile1))==NULL)
#else
	if((tmpfile1=fopenpathlist(argv[j0+j-1]))==NULL)
#endif
	  return Exit_openpathfile;
	dlen=aiffdata[j-1].datalen;
	if(len>0 && dlen>=len*a_bs)
	  putfile2file(tmpfile1,stdout,aiffdata[j-1].hlen,len*a_bs);
	else{
	    if(addsp==-1 && dlen<len*a_bs){
		a_blocks=(len-dlen/a_bs)*a_ch;
		for(k=1;k<=a_blocks;k++)
		  if(a_byte==1) putchar(AIFF8NULL);
		  else writelittleito2byte(stdout,AIFF16NULL);
	    }
	    putfile2file(tmpfile1,stdout,aiffdata[j-1].hlen,dlen);
	    if(addsp==1 && dlen<len*a_bs){
		a_blocks=(len-dlen/a_bs)*a_ch;
		for(k=1;k<=a_blocks;k++)
		  if(a_byte==1) putchar(AIFF8NULL);
		  else writelittleito2byte(stdout,AIFF16NULL);
	    }
	}
	fclose(tmpfile1);
#ifdef USEFREOPEN
	tmpfile1=NULL;
#endif
    }
    return No_err;
}

/* ########## usage ########## */
void usage(void)
{
    char *mess[]={
	"Usage: aiffconn [options] [aifffile] ([aifffile] ...)",
	" options:",
	"   -p[path]: aifffile ѥ",
	"             (default= " DEF_Pathlist ")",
	"   -e[ext] : aifffile ĥ",
	"             (default= " DEF_Extlist ")",
	"   -f[file]: ե (default= " DEF_Conffname ")",
	"   -l      : aiff file ΥꥹȤΤɽ",
	"   -n[path]: nullfile ե̾ (default=ʤ)",
	"   -L[str] : ƲǤĹ (default=ĹϹͤˤĤʤ)",
	"             ([str] = (b|s)[Ĺ](+|-))",
	"   -r      : եإåϤʤ (default=Ϥ)",
	"   -q      : 顼ɽʤ",
	"   -h      : Υå",
	" ",
	" [1] ѥĥҤϡ (':') ǥߥȤʣǤ롣",
	" [2] եˤϡǥեȤθѥĥҤǤ롣",
	"     եǤ '#' ǻϤޤԤϥȤȸʤ졢Ԥ"
	"̵뤵롣",
	"     ԤΥեޥåȤ",
	"       [] [ꥹ]",
	"     Ǥꡢ[] ϸѥ \"path\", ĥҤ \"ext\" Ȥ롣",
	"     եǤ ':' ͭĹʤϡƱ"
	"ʣ",
	"     Ԥ񤱤Ф褤",
	" [3] ѥĥҤϡ줾Ķѿ " DEF_PathEnvname 
	", " DEF_ExtEnvname " ⻲Ȥ롣",
	"     ̤ͥ",
	"       ޥɥ饤 > Ķѿ > ե > ǥե",
	"     ν (ǥեȤϥѥΥǥեȤǡ"
	"ץ",
	"     βս default: Ȥƽ񤫤Ƥ)",
	" [4] nullfile ϡꤷե뤬ʤäѤ˻Ȥ"
	"ե",
	"     (̵ʤ)ΥեФƤ⸡ѥĥҤ"
	"ͭ",
	"     default Ǥ nullfile ϻѤ顼Ȥ롣"
	"Ķѿ " DEF_NULLFEnvname " Ǥ",
	"     ꡢեǤΥ \"nullfile\" ˤġ",
	"     ʤե̾Ȥ \"-\" ꤷ nullfile "
	"Ѥʤ",
	" [5] -L[str] ꤹȡƲǤꤷĹ·ƽϤ롣"
	"[str] ",
	"       b[num],b[num]+,b[num]-(==[num] block)",
	"       s[num],s[num]+,s[num]-(==[num] ߥ)",
	"      6 ̤ηǻǤ롣ǤĹĹĹ"
	"åȤ졢",
	"     Ĺû '+', '-' ǸˤĤƤ̵"
	"ʬä",
	"     ('+': ̵, '-': Ƭ̵) ŪĹ [num]"
	"·롣",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}

#endif /* __AIFFCONN_C__ */
